package edu.unca.cs.csci202.s2012.exam2;

import java.util.*;

/**
 *
 * @author J Dean Brock <brock@unca.edu>
 */
public class Problem6 {

    public static void questionAnswer() {
        String[] testCases = {
            "()()[][]",
            "[([])[()]]",
            "",
            "()(][]",
            "(()",
            "())"
        };
        for (String s : testCases) {
            System.out.println("Testing " + s);
            checkBalanced(s);
        }
    }

    private static void checkBalanced(String matchUp) {
        boolean unBalanced = false;
        Deque<Character> matchStack = new LinkedList<Character>();
        int i = 0;
        while (i < matchUp.length() && !unBalanced) {
            char nextC = matchUp.charAt(i);
            if (nextC == '(' || nextC == '[') {
                matchStack.push(nextC);
            } else if (matchStack.size() == 0) {
                unBalanced = true;
            } else {
                char matchC = matchStack.pop();
                if (matchC == '(') {
                    unBalanced = nextC != ')';
                } else /* matchMe == '[' */ {
                    unBalanced = nextC != ']';
                }
            }
            ++i ;
        }
        if (matchStack.size() != 0) {
            unBalanced = true ;
        }
        if (!unBalanced) {
            System.out.println("OK");
        }
    }
}
